#include <all_far.h>
#pragma hdrstop

#include "p_Int.h"

extern CONSTSTR StdCommands[];

CONSTSTR StdDialogLines[] = {
  "%*\xFA-61SrcPathname%",
  "%*\xFA-61DestPathname%",

  "\xC4" "Current %Cn%(%CurPc%)%>\xC4%",
  "   %+14CurSize%  %CurTime%      %CurCPS%    %CPS%",
  "   %+14CurFSize%  %CurRTime%         <%CurETime% %CurEDate%>",
  "%.Pc%-[%57Progress%]-",

  "\xC4" "Total %CnF%/%Cn%/%CnSkip%%>\xC4%",
  "   %+14TotSize%  %TotTime%                  %TotCps%",
  "   %+14TotFSize%  %TotRTime%         <%TotETime% %TotEDate%>",
  "%.FPercent%-[%57FProgress%]-",
  "-[%27CurPg%]-[%27SkipPg%]-"
};


void TrafficInformation::FormatLine( int num,CONSTSTR line,time_t tm )
  {  char     str[50];
     int      n,cn;
     InfoItem it;

    if ( num < 0 || num >= MAX_TRAF_LINES ||
         !line || !line[0] )
      return;

    for ( n = 0; *line && n < MAX_TRAF_WIDTH; line++ ) {
      //Char
      if ( *line != '%' ) {
        Lines[num][n++] = *line;
        continue;
      }
      //%
      if ( line[1] == '%' ) {
        line++;
        Lines[num][n++] = *line;
        continue;
      }
      line++;

      //Code
      if ( *line == '\\' ) {
        line++;
        for( cn = 0; *line && strchr("0123456789",*line) && cn < sizeof(str)-1; cn++,line++ )
          str[cn] = *line;
        str[cn] = 0;
        cn = atoi(str);
        if ( !cn || *line != '%' ) {
          FTP_Info->StrCpy( Lines[num]+n,"<badCmd>" );
          n += 8;
          break;
        }
        Lines[num][n++] = (char)cn;
        continue;
      }

      it.Type  = 0;
      it.Line  = num;
      it.Pos   = n;
      it.Align = tNone;
      it.Size  = 0;

      //Filler
      if ( *line == '*' ) {
        line++;
        it.Fill = *line;
        line++;
      } else
        it.Fill  = ' ';
      //Align
      if ( *line == '-' ) it.Align = tLeft; else
      if ( *line == '+' ) it.Align = tRight; else
      if ( *line == '.' ) it.Align = tCenter; else
      if ( *line == '>' ) {
      //Right line
        line++;
        it.Fill = *line++;
        if ( *line != '%' ) {
          FTP_Info->StrCpy( Lines[num]+n,"<badCmd>" );
          n += 8;
          break;
        }
        if ( Count >= MAX_TRAF_ITEMS ) {
          FTP_Info->StrCpy( Lines[num]+n,"<many>" );
          break;
        }
        it.Align = tRightFill;
        Items[Count++] = it;
        continue;
      }

      if ( it.Align != tNone )
        line++;

      //Size
      if ( isdigit( *line ) ) {
        for( cn = 0; *line && strchr("+-0123456789",*line) && cn < sizeof(str)-1; cn++,line++ )
          str[cn] = *line;
        str[cn] = 0;

        it.Size = atoi(str);
      }

      //Type
      for( cn = 0; *line && *line != '%' && cn < sizeof(str)-1; cn++,line++ )
        str[cn] = *line;
      str[cn] = 0;

      for ( cn = 0; StdCommands[cn]; cn++ )
        if ( FTP_Info->StrCmp(StdCommands[cn],str,-1,FALSE) == 0 )
          break;

      if ( *line == 0 || !StdCommands[cn] ) {
        FTP_Info->StrCpy( Lines[num]+n,"<badCmd>" );
        n += 8;
        break;
      }
      it.Type = cn;

      //Wide center
      if ( it.Align == tCenter && !it.Size ) {
        if ( Count >= MAX_TRAF_ITEMS ) {
          FTP_Info->StrCpy( Lines[num]+n,"<many>" );
          break;
        }
        Items[Count++] = it;
        continue;
      }

      //Draw
      DrawInfo( &it,tm );
      n += it.Size;
    }
    Lines[num][n] = 0;
}

void TrafficInformation::DrawInfos( time_t tm )
  {  char str[ MAX_TRAF_WIDTH+1 ];
     char key[ MAX_TRAF_WIDTH+1 ];
     int  n,i;

    Count = 0;

    FTP_Info->SNprintf( key,sizeof(key),"CopyDialog\\%s",FTP_Info->GetMsg(MLanguage) );
    LineCount = Min( MAX_TRAF_LINES,FTP_Info->GetRegKeyFullInt( key,"Count", 0 ) );
    if ( !LineCount ) {
      LineCount = sizeof(StdDialogLines) / sizeof(StdDialogLines[0]);
      for ( i = 0; i < LineCount; i++ )
        FormatLine( i,StdDialogLines[i],tm );
    } else {
      for ( i = 0; i < LineCount; i++ ) {
        FTP_Info->GetRegKeyFullStr( key, FTP_Info->Message("Line%02d",i+1), str,"",sizeof(str) );
        if ( !str[0] ) break;
        FormatLine( i,str,tm );
      }
      LineCount = i;
    }

    if ( !Count )
      return;

    int w = 0;
    for ( w = n = 0; n < LineCount; n++ )
      w = Max( w,FTP_Info->strLen(Lines[n]) );

    for ( n = 0; n < LineCount; n++ )
      if ( Lines[n][0] != '\x1' && Lines[n][0] != '\x2' ) {
        for( i = FTP_Info->strLen(Lines[n]); i < w; i++ )
          Lines[n][i] = ' ';
        Lines[n][i] = 0;
      }

    for ( n = 0; n < Count; n++ ) {
      //Center
      if ( Items[n].Align == tCenter )
        Items[n].Pos = w/2 - Items[n].Size/2;
       else
      if ( Items[n].Align == tRightFill )
        Items[n].Size = w - Items[n].Pos;
      if ( FTP_Info->strLen(Lines[Items[n].Line]) > Items[n].Pos )
        DrawInfo( &Items[n],tm );
    }

    for ( n = 0; n < LineCount; n++ )
      Lines[n][w] = 0;
}

void TrafficInformation::Init( HANDLE h,int tMsg,int OpMode,PFTPItemList il )
  {
    memset( this,0,sizeof(*this) );
    memset( Lines,' ',MAX_TRAF_LINES*MAX_TRAF_WIDTH );

    TitleMsg       = tMsg;
    ShowStatus     = !IS_SILENT(OpMode);
    hConnect       = h;
    TotalStartTime = time(NULL);
    FullFileSize   = -1;

    if ( il )
      for ( int i = 0; i < il->Count(); i++ )
        if ( !IS_FLAG(il->List[i].FindData.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY) &&
             il->List[i].FindData.dwReserved1 != MAX_DWORD ) {
          TotalFullSize += ((TRINT)il->List[i].FindData.nFileSizeHigh) * ((TRINT)MAX_DWORD) +
                           ((TRINT)il->List[i].FindData.nFileSizeLow);
          TotalFiles++;
        }
}

void TrafficInformation::InitFile( PluginPanelItem *pi,CONSTSTR SrcName,CONSTSTR DestName )
  {
    if ( FullFileSize != -1 ) {
      TotalComplete++;
      TotalFiles    = Max( TotalFiles,TotalSkipped+TotalComplete );
      TotalSize    += FullFileSize;
      TotalFullSize = Max( TotalSize,TotalFullSize );
      //Callback(0);
    }

    FullFileSize       = ((TRINT)pi->FindData.nFileSizeHigh) * ((TRINT)MAX_DWORD) +
                         ((TRINT)pi->FindData.nFileSizeLow);
    FileSize           = 0;
    LastSize           = 0;
    StartFileSize      = 0;
    Cps                = 0;
    FileStartTime      = time(NULL);
    FileWaitTime       = 0;
    AvCps[0] = 0; AvCps[1] = 0; AvCps[2] = 0;
    GET_TIME( LastTime );

    FTP_Info->StrCpy( SrcFileName,SrcName,sizeof(SrcFileName) );
    FTP_Info->StrCpy( DestFileName,DestName,sizeof(DestFileName) );
}

void TrafficInformation::Skip( void )
  {
    TotalStartSize  += FullFileSize;
    TotalSkipped++;
    TotalFiles      = Max( TotalFiles,TotalSkipped+TotalComplete );
    StartFileSize   = 0;
    FileSize        = 0;
}

void TrafficInformation::Resume( CONSTSTR nm )
  {  WIN32_FIND_DATA ffi;
     HANDLE          ff = FindFirstFile(nm,&ffi);

     if ( ff == INVALID_HANDLE_VALUE ) {
       StartFileSize   = 0;
       FileSize        = 0;
       return;
     }
     FindClose(ff);

     StartFileSize   = ((TRINT)ffi.nFileSizeHigh) * ((TRINT)MAX_DWORD) +
                       ((TRINT)ffi.nFileSizeLow);
     FileSize        = 0;
}

void TrafficInformation::Resume( TRINT size )
  {
     StartFileSize   = size;
     FileSize        = 0;
}

void TrafficInformation::Waiting( time_t tm )
  {
     TotalWaitTime += tm;
     FileWaitTime  += tm;
}
/****************************************
    Callback called from GetFiles and PutFiles each time whole buffer
    sended or received to refresh state of copy progress
    Can be called in any plugin state (quite, not show, etc)
 ****************************************/
BOOL TrafficInformation::Callback( int Size )
  {  CMP_TIME_TYPE tmDiff;
     TIME_TYPE     tm;
     time_t        tmt;
     char          str[ FAR_MAX_PATHSIZE ];
     double        TotalPercent,db;

    GET_TIME( tm );
    tmDiff = Abs( CMP_TIME( tm,LastTime ) );
    tmt = time(NULL);

    FileSize     += Size;
    FullFileSize  = Max( FileSize,FullFileSize );

    if ( Size && tmDiff < 0.4 )
      return TRUE;

    if ( FTP_Info->CheckForEsc(FALSE) ) {
      Log(( "User cancel" ));
      return FALSE;
    }

    memmove( &LastTime,&tm,sizeof(LastTime) );

    TotalPercent = ToPercent( TotalSz(),TotalFullSize );
    //Avg
    if ( tmDiff > 0 ) {
      AvCps[0] = AvCps[1];
      AvCps[1] = AvCps[2];
      AvCps[2] = (FileSize - LastSize) / tmDiff;
    }
    LastSize = FileSize;
    //Cur
    db = ((double)tmt-FileStartTime-FileWaitTime);
    if ( db > 0 )
      Cps = FileSize / db;
     else
      Cps = 0;
    //Total
    db = ((double)tmt-TotalStartTime-TotalWaitTime);
    if ( db > 0 )
      TotalCps = (TotalSize+FileSize) / db;
     else
      TotalCps = 0;

//Show QUIET progressing
    if ( !ShowStatus ) {
      if ( FTP_Info->Option(FTP_OPT_SHOWIDLE) ) {
        FTP_Info->SNprintf( str,sizeof(str),"{%2.1lf%%} %s: %.26s",
                           TotalPercent,
                           FTP_Info->GetMsg(TitleMsg),
                           FTP_Info->PointToName(SrcFileName) );
        FTP_Info->IdleMessage( str,(int)FTP_Info->Option(FTP_OPT_PROCESSCOLOR) );
      }
      return TRUE;
    }

//Window caption
    if ( FTP_Info->FtpGetRetryCount(hConnect) )
      FTP_Info->SNprintf( str,sizeof(str),"%d: {%2.1lf%%} %s - Far",
                         FTP_Info->FtpGetRetryCount(hConnect), TotalPercent,
                         FTP_Info->GetMsg(TitleMsg) );
     else
      FTP_Info->SNprintf( str,sizeof(str),"{%2.1lf%%} %s - Far",
                         TotalPercent,FTP_Info->GetMsg(TitleMsg) );

     if ( FTP_Info->StrCmp(str,ConsoleTitle,-1,TRUE) != 0 ) {
       if ( FTP_Info->WinVer->dwPlatformId != VER_PLATFORM_WIN32_NT )
         OemToChar(str,str);
       SetConsoleTitle(str);
       FTP_Info->StrCpy( ConsoleTitle,str,sizeof(ConsoleTitle) );
     }

//Mark CMD window invisible
    FTP_Info->FtpCmdBlock(hConnect,TRUE);

//Show message
    CONSTSTR MsgItems[MAX_TRAF_LINES+1];

    DrawInfos( tmt );

    if ( FTP_Info->FtpGetRetryCount(hConnect) )
      FTP_Info->SNprintf( str,sizeof(str),"%d: %s",FTP_Info->FtpGetRetryCount(hConnect),FTP_Info->GetMsg(TitleMsg) );
     else
      FTP_Info->StrCpy( str,FTP_Info->GetMsg(TitleMsg),sizeof(str) );
    MsgItems[0] = str;

    int n;
    for ( n = 0; n < LineCount; n++ )
      MsgItems[n+1] = Lines[n];

    FTP_Info->FMessage( FMSG_LEFTALIGN, NULL,
                        (const char **)MsgItems, LineCount+1, 0 );

 return TRUE;
}
