#include <all_far.h>
#pragma hdrstop

#include <fstdlib.h>
#include "ftp_Plugin.h"

PFTPInterface FTP_Info = NULL;

/*******************************************************************
   INTERFACE
 *******************************************************************/
FAR_EXTERN PFTPPluginInterface FAR_DECLSPEC FTPQueryInterface( PFTPInterface Info )
  {
     if ( Info->Magic != FTP_INTERFACE_MAGIC ||
          Info->SizeOf != sizeof(FTPInterface) )
       return NULL;

     FTP_Info = Info;

 return FTPPluginGetInterface();
}

/*******************************************************************
   INTERFACE
 *******************************************************************/
#if defined(__BORLAND)
BOOL WINAPI DllEntryPoint( HINSTANCE hinst, DWORD reason, LPVOID ptr )
  {  BOOL rc = FTP_PluginStartup(reason);

     if ( reason == DLL_PROCESS_DETACH )
       FTP_Info = NULL;

 return rc;
}
#else
#if defined(__MSOFT)
BOOL WINAPI DllMain( HINSTANCE hinst, DWORD reason, LPVOID ptr )
  {  BOOL rc = FTP_PluginStartup(reason);

     if ( reason == DLL_PROCESS_DETACH )
       FTP_Info = NULL;

 return rc;
}
#else
  #error "Define plugin DLL entry point procedure for your  compiller"
#endif
#endif

/*******************************************************************
   CPP MEMORY
 *******************************************************************/
BOOL _RTLCheck( CONSTSTR fnm )
  {
     if ( !FTP_Info ) {
       MessageBox( NULL,
                   "FTP_Info is not defined in FTP subplugin",
                   fnm, MB_OK );
       abort();
       return FALSE;
     }
 return TRUE;
}

#define RTLCheck( v,dz ) if ( !_RTLCheck(v) ) { dz; }

void __cdecl operator delete( void *ptr )   { RTLCheck("delete",return)              FTP_Info->Del( ptr ); }
void *__cdecl operator new( size_t sz )     { RTLCheck("new",return NULL)            return FTP_Info->Alloc(sz); }

#if defined(__BORLANDC__)
 #if sizeof(size_t) < sizeof(long)
  void *operator new( unsigned long sz )    { RTLCheck("new(long)",return NULL)      return FTP_Info->Alloc(sz); }
 #endif
#endif

#if defined( __HWIN__ ) || defined( __QNX__ )
void __cdecl operator delete[]( void *ptr ) { RTLCheck("delete[]",return)            FTP_Info->Del( ptr ); }
void *__cdecl operator new[]( size_t sz )   { RTLCheck("new[]",return NULL)          return FTP_Info->Alloc(sz); }
#endif

LPVOID FP_DECLSPEC _Alloc( DWORD sz )               { RTLCheck("_Alloc",     return NULL)  return FTP_Info->Alloc(sz); }
void   FP_DECLSPEC _Del( LPVOID ptr )               { RTLCheck("_Del",       return)       FTP_Info->Del(ptr); }
LPVOID FP_DECLSPEC _Realloc( LPVOID ptr,DWORD sz )  { RTLCheck("_Realloc",   return NULL)  return FTP_Info->Realloc(ptr,sz); }
DWORD  FP_DECLSPEC _PtrSize( LPVOID ptr )           { RTLCheck("_PtrSize",   return 0)     return FTP_Info->PtrSize(ptr); }
BOOL   FP_DECLSPEC _HeapCheck( void )               { RTLCheck("_HeapCheck", return FALSE) return FTP_Info->HeapCheck(); }
